/* Plays an audio track and turns on and off LEDs based on the
 * commands stored in the ID3 tag (the SYLT frame).
 *
 * The commands have the form "+14 -12", where the numbers stand
 * for the I/O pins, and "+" and "-" mean "turn on" and "turn
 * off" respectively. So in this example, I/O pin 14 is turned
 * on and I/O pin 12 is turned off.
 */

main()
    {
    /* configure 4 I/O pins as output */
    for (new i = 12; i <= 15; i++)
        configiopin i, Output

    /* Orb Gettarr: "From The Machine World"
     * See: http://www.opsound.org/opsound/pool/gettarr.html
     */
    play !"From-The-Machine-World.mp3"
    }

@synch(const event[])
    {
    for (new index = 0; /* test is in the middle */ ; index++)
        {
        /* find first '+' or '-' */
        new c
        while ((c = event{index}) != '-' && c != '+' && c != EOS)
            index++
        if (c == EOS)
            break       /* exit the loop on an End-Of-String */

        /* get the value behind the operator ('+' or '-') */
        new pin = strval(event, index + 1)

        /* turn on or off the led (based on the operator) */
        setiopin pin, (c == '+')
        }
    }
